#include <array>
#include <future>
#include <iostream>
#include <libpq-fe.h>
#include <thread>
#include <unistd.h>
#include <vector>
#include <poll.h>

constexpr int CONNECTIONS{2};

void init_connection() {
  /* Make a connection to the database */
  PGconn *conn =
      PQconnectdb("host=127.0.0.1 user=wmann password=dbtest sslmode=require "
                  "dbname=filtered_pu connect_timeout=100");
  if (PQstatus(conn) == CONNECTION_BAD) {
    fprintf(stderr, "Connection attempt failed: %s", PQerrorMessage(conn));
  }
}

void poll0() {
    pollfd p;
    p.fd = 0;
    p.events = POLLPRI | POLLIN;
    int ret = poll(&p, 1, 5000);
    std::string type;
    if(ret) {
        if(p.revents | POLLERR) {
        type += "POLLERR";
        }
        if(p.revents | POLLNVAL) {
            type += "POLLNVAL";
        }
        if(p.revents | POLLHUP) {
            type += POLLHUP;
        }
        std::cerr << "stdin: " << type << "\n";
    } else {
        std::cerr << "stdin still open\n";
    }
}

int main(void) {
  std::vector<std::future<void>> results(CONNECTIONS);
  for (int i = 0; i < CONNECTIONS; ++i) {
    results[i] = std::async([] { init_connection(); });
  }
  poll0();
  for (int i = 0; i < CONNECTIONS; ++i) {
    results[i].get();
  }
}
